package gregapi.data;

import static gregapi.data.CS.SIDE_ANY;
import gregapi.code.TagData;
import gregapi.lang.LanguageHandler;
import gregapi.tileentity.energy.ITileEntityEnergy;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.util.EnumChatFormatting;

/**
 * @author Gregorius Techneticies
 * 
 * Contains common translatable Strings.
 */
public class LH {
	public static final String
	  EFFICIENCY = "gt.lang.efficiency"
	, RECIPE = "gt.lang.recipe"
	, RECIPES = "gt.lang.recipes"
	, RECIPES_MOLD = "gt.lang.recipes.mold"
	, RECIPES_MOLD_SELECT = "gt.lang.recipes.mold.select"
	, RECIPES_MOLD_COINAGE = "gt.lang.recipes.mold.coinage"
	, RECIPES_SIFTER_USAGE = "gt.lang.recipes.sifter.usage"
	, RECIPES_MIXINGBOWL_USAGE = "gt.lang.recipes.mixingbowl.usage"
	, RECIPES_BATHINGPOT_USAGE = "gt.lang.recipes.bathingsink.usage"
	, RECIPES_GRINDSTONE_USAGE = "gt.lang.recipes.grindstone.usage"
	, RECIPES_GRINDSTONE_INIT = "gt.lang.recipes.grindstone.init"
	, RECIPES_DUSTFUNNEL = "gt.lang.recipes.dustfunnel"
	, RECIPES_AUTOHAMMER = "gt.lang.recipes.autohammer"
	, RECIPES_IGNITER = "gt.lang.recipes.igniter"
	, RECIPES_QUALITY = "gt.lang.recipes.quality"
	, ENERGY_CONTAINED = "gt.lang.energy.contained"
	, ENERGY_CAPACITY = "gt.lang.energy.capacity"
	, ENERGY_OUTPUT = "gt.lang.energy.output"
	, ENERGY_INPUT = "gt.lang.energy.input"
	, ITEM_OUTPUT = "gt.lang.item.output"
	, ITEM_INPUT = "gt.lang.item.input"
	, FLUID_OUTPUT = "gt.lang.fluid.output"
	, FLUID_INPUT = "gt.lang.fluid.input"
	, CONVERTS_FROM_X = "gt.lang.energy.convert.from"
	, CONVERTS_TO_Y = "gt.lang.energy.convert.to"
	, CONVERTS_USING_Z = "gt.lang.energy.convert.using"
	, CONVERTS_PER_Z = "gt.lang.energy.convert.per"
	, FACE_ANY = "gt.lang.face.any"
	, FACE_BOTTOM = "gt.lang.face.bottom"
	, FACE_TOP = "gt.lang.face.top"
	, FACE_LEFT = "gt.lang.face.left"
	, FACE_FRONT = "gt.lang.face.front"
	, FACE_RIGHT = "gt.lang.face.right"
	, FACE_BACK = "gt.lang.face.back"
	, FACE_NONE = "gt.lang.face.none"
	, FACES[] = {FACE_BOTTOM, FACE_TOP, FACE_LEFT, FACE_FRONT, FACE_RIGHT, FACE_BACK, FACE_NONE}
	, FACE_SIDES = "gt.lang.face.sides"
	, FACE_FRONT_BACK = "gt.lang.face.front.back"
	, FACE_ANYBUT_FRONT_BACK = "gt.lang.face.any.but.front.back"
	, FACE_ANYBUT_BOTTOM = "gt.lang.face.any.but.bottom"
	, FACE_ANYBUT_TOP = "gt.lang.face.any.but.top"
	, FACE_ANYBUT_LEFT = "gt.lang.face.any.but.left"
	, FACE_ANYBUT_FRONT = "gt.lang.face.any.but.front"
	, FACE_ANYBUT_RIGHT = "gt.lang.face.any.but.right"
	, FACE_ANYBUT_BACK = "gt.lang.face.any.but.back"
	, FACE_ANYBUT_SIDES = "gt.lang.face.any.but.sides"
	, REQUIREMENT_AIR_IN_FRONT = "gt.lang.requirement.air.front"
	, REQUIREMENT_EMPTY_ASHES = "gt.lang.requirement.empty.ashes"
	, REQUIREMENT_IGNITE_FIRE = "gt.lang.requirement.ignite.fire"
	, REQUIREMENT_WATER = "gt.lang.requirement.water"
	, REQUIREMENT_WATER_ANY = "gt.lang.requirement.water.any"
	, REQUIREMENT_WATER_PURE = "gt.lang.requirement.water.pure"
	, REQUIREMENT_DISTILLED_WATER = "gt.lang.requirement.water.distilled"
	, REQUIREMENT_CHUNKLOADER = "gt.lang.requirement.chunk.loader"
	, EMITS_USED_STEAM = "gt.lang.emits.used.steam"
	, EMITS_REDSTONE_FLUX = "gt.lang.emits.redstoneflux.lossless"
	, EMITS_REDSTONE_FLUX_LOSS = "gt.lang.emits.redstoneflux.lossy"
	, ACCEPTS_REDSTONE_FLUX = "gt.lang.accepts.redstoneflux.lossless"
	, ACCEPTS_REDSTONE_FLUX_LOSS = "gt.lang.accepts.redstoneflux.lossy"
	, NO_GUI_CLICK_TO_INTERACT = "gt.lang.nogui.rightclick.interact"
	, NO_GUI_CLICK_TO_INVENTORY = "gt.lang.nogui.rightclick.inventory"
	, NO_GUI_CLICK_TO_TANK = "gt.lang.nogui.rightclick.tank"
	, OWNER_CONTROLLED = "gt.lang.owner.controlled"
	, KEY_CONTROLLED = "gt.lang.key.controlled"
	, COVER_TOOLTIP = "gt.lang.cover.tooltip"
	, TOOL_TO_SET_FACING_PRE = "gt.lang.use.x.to.toggle.facing.pre"
	, TOOL_TO_SET_FACING_POST = "gt.lang.use.x.to.toggle.facing.post"
	, TOOL_TO_SET_CONNECTIONS_PRE = "gt.lang.use.x.to.toggle.connection.pre"
	, TOOL_TO_SET_CONNECTIONS_POST = "gt.lang.use.x.to.toggle.connection.post"
	, TOOL_TO_SET_DIRECTION_MONKEY_WRENCH = "gt.lang.use.monkey.wrench.to.toggle.direction"
	, TOOL_TO_SET_INPUT_MONKEY_WRENCH = "gt.lang.use.monkey.wrench.to.set.input.side"
	, TOOL_TO_SET_OUTPUT_MONKEY_WRENCH = "gt.lang.use.monkey.wrench.to.set.output.side"
	, TOOL_TO_TOGGLE_INPUTS_MONKEY_WRENCH = "gt.lang.use.monkey.wrench.to.toggle.inputs"
	, TOOL_TO_TOGGLE_OUTPUTS_MONKEY_WRENCH = "gt.lang.use.monkey.wrench.to.toggle.outputs"
	, TOOL_TO_TOGGLE_AUTO_INPUTS_MONKEY_WRENCH = "gt.lang.use.monkey.wrench.to.toggle.auto.inputs"
	, TOOL_TO_TOGGLE_AUTO_OUTPUTS_MONKEY_WRENCH = "gt.lang.use.monkey.wrench.to.toggle.auto.outputs"
	, TOOL_TO_TOGGLE_SOFT_HAMMER = "gt.lang.use.soft.hammer.to.toggle"
	, TOOL_TO_RESET_SOFT_HAMMER = "gt.lang.use.soft.hammer.to.reset"
	, TOOL_TO_TOGGLE_SCREWDRIVER = "gt.lang.use.screwdriver.to.toggle"
	, TOOL_TO_CHANGE_DESIGN_CHISEL = "gt.lang.use.chisel.to.switch.design"
	, TOOL_TO_HARVEST = "gt.lang.tool.to.harvest"
	, WIRE_STATS_LOSS = "gt.lang.wire.stats.loss"
	, WIRE_STATS_VOLTAGE = "gt.lang.wire.stats.voltage"
	, WIRE_STATS_AMPERAGE = "gt.lang.wire.stats.amperage"
	, PIPE_STATS_LOSS = "gt.lang.pipe.stats.loss"
	, PIPE_STATS_RANGE = "gt.lang.pipe.stats.range"
	, PIPE_STATS_STEPSIZE = "gt.lang.pipe.stats.stepsize"
	, PIPE_STATS_BANDWIDTH = "gt.lang.pipe.stats.bandwidth"
	, PIPE_STATS_CAPACITY = "gt.lang.pipe.stats.capacity"
	, HAZARD_FIRE = "gt.lang.hazard.fire"
	, HAZARD_EXPLOSION_STEAM = "gt.lang.hazard.explosion.steam"
	, HAZARD_MELTDOWN = "gt.lang.hazard.meltdown"
	, HAZARD_CONTACT = "gt.lang.hazard.contact"
	, HAZARD_LEAKING_GAS = "gt.lang.hazard.leak.gas"
	, TOOLTIP_SPAWNPROOF = "gt.lang.spawnproof"
	, TOOLTIP_BLASTRESISTANCE = "gt.lang.blastresistance"
	, ADVCRAFTING_INSERT_BLUEPRINT = "gt.advcrafting.insert.blueprint"
	, ADVCRAFTING_PUT_TO_STORAGE = "gt.advcrafting.put.to.storage"
	, ADVCRAFTING_AUTOMATION_ACCESS = "gt.advcrafting.automation.access"
	, ADVCRAFTING_NEUTRAL_SLOT = "gt.advcrafting.neutral.slot"
	, ADVCRAFTING_DROP_SLOT = "gt.advcrafting.drop.slot"
	, TIME_TICK = "gt.lang.time.tick"
	, TIME_SEC = "gt.lang.time.second"
	, TIME_MIN = "gt.lang.time.minute"
	, TIME_HOUR = "gt.lang.time.hour"
	, TIME_DAY = "gt.lang.time.day"
	, TIME_WEEK = "gt.lang.time.week"
	, TIME_TICKS = "gt.lang.time.ticks"
	, TIME_SECS = "gt.lang.time.seconds"
	, TIME_MINS = "gt.lang.time.minutes"
	, TIME_HOURS = "gt.lang.time.hours"
	, TIME_DAYS = "gt.lang.time.days"
	, TIME_WEEKS = "gt.lang.time.weeks"
	, WIP = "gt.lang.work.in.progress"
	;
	
	public static final void add(String aKey, String aEnglish) {LanguageHandler.add(aKey, aEnglish);}
	public static final String get(String aKey) {return LanguageHandler.translate(aKey);}
	
	public static final String getToolTipEfficiency(long aEfficiency) {aEfficiency = Math.abs(aEfficiency); return Chat.YELLOW + get(EFFICIENCY) + ": " + Chat.WHITE + (aEfficiency/100) +"."+ (aEfficiency%100) + "%";}
	
	public static final void addEnergyToolTips(ITileEntityEnergy aTileEntity, List aToolTips, TagData aEnergyTypeIN, TagData aEnergyTypeOUT, String aSidesIN, String aSidesOUT) {
		if (aEnergyTypeIN != null)
		aToolTips.add(Chat.GREEN	+ LH.get(LH.ENERGY_INPUT)			+ ": " + Chat.WHITE + aTileEntity.getEnergySizeInputRecommended (aEnergyTypeIN , SIDE_ANY) + " " + aEnergyTypeIN .getChatFormat()	+ aEnergyTypeIN .getLocalisedNameShort()	+ Chat.WHITE + "/t ("+aTileEntity.getEnergySizeInputMin (aEnergyTypeIN , SIDE_ANY)+" to "+aTileEntity.getEnergySizeInputMax (aEnergyTypeIN , SIDE_ANY)+(UT.Code.stringInvalid(aSidesIN )?"":", "+aSidesIN )+")");
		if (aEnergyTypeOUT != null)
		aToolTips.add(Chat.RED		+ LH.get(LH.ENERGY_OUTPUT)			+ ": " + Chat.WHITE + aTileEntity.getEnergySizeOutputRecommended(aEnergyTypeOUT, SIDE_ANY) + " " + aEnergyTypeOUT.getChatFormat()	+ aEnergyTypeOUT.getLocalisedNameShort()	+ Chat.WHITE + "/t ("+aTileEntity.getEnergySizeOutputMin(aEnergyTypeOUT, SIDE_ANY)+" to "+aTileEntity.getEnergySizeOutputMax(aEnergyTypeOUT, SIDE_ANY)+(UT.Code.stringInvalid(aSidesOUT)?"":", "+aSidesOUT)+")");
//		if (aEnergyTypeIN != null)
//		aToolTips.add(getToolTipRedstoneFluxAccept(aEnergyTypeIN));
		if (aEnergyTypeOUT != null)
		aToolTips.add(getToolTipRedstoneFluxEmit(aEnergyTypeOUT));
	}
	
	public static final String getToolTipRedstoneFluxEmit(TagData aEnergyType) {
		if (aEnergyType == TD.Energy.KU) return Chat.ORANGE + LH.get(LH.EMITS_REDSTONE_FLUX_LOSS)+" 50%";
		if (aEnergyType == TD.Energy.RF) return Chat.ORANGE + LH.get(LH.EMITS_REDSTONE_FLUX);
		if (aEnergyType == TD.Energy.MJ) return Chat.ORANGE + LH.get(LH.EMITS_REDSTONE_FLUX);
		return null;
	}
	
	public static final String getToolTipRedstoneFluxAccept(TagData aEnergyType) {
		if (aEnergyType == TD.Energy.KU) return Chat.ORANGE + LH.get(LH.ACCEPTS_REDSTONE_FLUX_LOSS)+" 50%";
		if (aEnergyType == TD.Energy.RF) return Chat.ORANGE + LH.get(LH.ACCEPTS_REDSTONE_FLUX);
		if (aEnergyType == TD.Energy.MJ) return Chat.ORANGE + LH.get(LH.ACCEPTS_REDSTONE_FLUX);
		return null;
	}
	
	static {
		add(EFFICIENCY									, "Efficiency");
		add(RECIPE										, "Recipe");
		add(RECIPES										, "Recipes");
		add(RECIPES_MOLD								, "This Mold produces");
		add(RECIPES_MOLD_SELECT							, "Use a Chisel in order to select the Shape of the Mold");
		add(RECIPES_MOLD_COINAGE						, "Place tiny Metal Plate ontop, hammer it and retrieve Coin");
		add(RECIPES_SIFTER_USAGE						, "Place Input on Top and rightclick it");
		add(RECIPES_MIXINGBOWL_USAGE					, "Place Input on Top and rightclick it");
		add(RECIPES_BATHINGPOT_USAGE					, "Place Input on Top and rightclick it");
		add(RECIPES_GRINDSTONE_USAGE					, "Click multiple times with the Object you want to sharpen");
		add(RECIPES_GRINDSTONE_INIT						, "Add Sandstone Block in order to be able to use this");
		add(RECIPES_DUSTFUNNEL							, "Turns all differently sized Dusts into the specified Size");
		add(RECIPES_AUTOHAMMER							, "Performs Hammer Rightclicks and crushes Blocks");
		add(RECIPES_IGNITER								, "Performs Ignition Rightclicks and incinerates Blocks");
		add(RECIPES_QUALITY								, "This has a Tool Quality of");
		add(ENERGY_CONTAINED							, "Stored Energy");
		add(ENERGY_CAPACITY								, "Capacity");
		add(ENERGY_OUTPUT								, "Energy OUT");
		add(ENERGY_INPUT								, "Energy IN");
		add(ITEM_OUTPUT									, "Items OUT");
		add(ITEM_INPUT									, "Items IN");
		add(FLUID_OUTPUT								, "Fluids OUT");
		add(FLUID_INPUT									, "Fluids IN");
		add(CONVERTS_FROM_X								, "Converts");
		add(CONVERTS_TO_Y								, "into");
		add(CONVERTS_USING_Z							, "using");
		add(CONVERTS_PER_Z								, "per");
		add(FACE_ANY									, "Any Side");
		add(FACE_BOTTOM									, "Bottom");
		add(FACE_TOP									, "Top");
		add(FACE_LEFT									, "Left");
		add(FACE_FRONT									, "Front");
		add(FACE_RIGHT									, "Right");
		add(FACE_BACK									, "Back");
		add(FACE_NONE									, "None");
		add(FACE_SIDES									, "Sides");
		add(FACE_FRONT_BACK								, "Front and Back");
		add(FACE_ANYBUT_FRONT_BACK						, "Any but Front and Back");
		add(FACE_ANYBUT_BOTTOM							, "Any but Bottom");
		add(FACE_ANYBUT_TOP								, "Any but Top");
		add(FACE_ANYBUT_LEFT							, "Any but Left");
		add(FACE_ANYBUT_FRONT							, "Any but Front");
		add(FACE_ANYBUT_RIGHT							, "Any but Right");
		add(FACE_ANYBUT_BACK							, "Any but Back");
		add(FACE_ANYBUT_SIDES							, "Any but Sides");
		add(REQUIREMENT_AIR_IN_FRONT					, "Requires Air in front to work!");
		add(REQUIREMENT_EMPTY_ASHES						, "Requires Ashes to be extracted regularly!");
		add(REQUIREMENT_IGNITE_FIRE						, "Requires ignition by Flint and Tinder or similar!");
		add(REQUIREMENT_WATER							, "Requires input of Water!");
		add(REQUIREMENT_WATER_ANY						, "Requires input of any Water!");
		add(REQUIREMENT_WATER_PURE						, "Requires any Water. Use distilled Water for best efficiency!");
		add(REQUIREMENT_DISTILLED_WATER					, "Requires input of distilled Water!");
		add(REQUIREMENT_CHUNKLOADER						, "Needs to be in a loaded Chunk to work properly!");
		add(EMITS_USED_STEAM							, "Emits used Steam");
		add(EMITS_REDSTONE_FLUX							, "Can emit Redstone Flux (RF) losslessly");
		add(EMITS_REDSTONE_FLUX_LOSS					, "Can emit Redstone Flux (RF) with a Loss of");
		add(ACCEPTS_REDSTONE_FLUX						, "Can accept Redstone Flux (RF) losslessly");
		add(ACCEPTS_REDSTONE_FLUX_LOSS					, "Can accept Redstone Flux (RF) with a Loss of");
		add(NO_GUI_CLICK_TO_INTERACT					, "No GUI, Click to interact!");
		add(NO_GUI_CLICK_TO_INVENTORY					, "No GUI, Click to insert/extract Items!");
		add(NO_GUI_CLICK_TO_TANK						, "No GUI, Click with Fluid Container to interact!");
		add(OWNER_CONTROLLED							, "This Block can only be interacted with by its Owner!");
		add(KEY_CONTROLLED								, "This Block can only be opened with a Key!");
		add(COVER_TOOLTIP								, "This Item can be used as Cover.");
		add(TOOL_TO_CHANGE_DESIGN_CHISEL				, "Use Chisel to change Design");
		add(TOOL_TO_TOGGLE_SCREWDRIVER					, "Use Screwdriver to Toggle Modes");
		add(TOOL_TO_RESET_SOFT_HAMMER					, "Use Soft Hammer to Reset");
		add(TOOL_TO_TOGGLE_SOFT_HAMMER					, "Use Soft Hammer to Toggle States");
		add(TOOL_TO_TOGGLE_INPUTS_MONKEY_WRENCH			, "Use Monkey Wrench to Toggle Inputs");
		add(TOOL_TO_TOGGLE_OUTPUTS_MONKEY_WRENCH		, "Use Monkey Wrench to Toggle Outputs");
		add(TOOL_TO_TOGGLE_AUTO_INPUTS_MONKEY_WRENCH	, "Use Monkey Wrench to Toggle automatic Inputs");
		add(TOOL_TO_TOGGLE_AUTO_OUTPUTS_MONKEY_WRENCH	, "Use Monkey Wrench to Toggle automatic Outputs");
		add(TOOL_TO_SET_INPUT_MONKEY_WRENCH				, "Use Monkey Wrench to set Input Side");
		add(TOOL_TO_SET_OUTPUT_MONKEY_WRENCH			, "Use Monkey Wrench to set Output Side");
		add(TOOL_TO_SET_DIRECTION_MONKEY_WRENCH			, "Use Monkey Wrench to set Direction");
		add(TOOL_TO_SET_FACING_PRE						, "Use ");
		add(TOOL_TO_SET_FACING_POST						, " to set Facing");
		add(TOOL_TO_SET_CONNECTIONS_PRE					, "Use ");
		add(TOOL_TO_SET_CONNECTIONS_POST				, " to set Connections");
		add(TOOL_TO_HARVEST								, "Tool to Harvest");
		add(WIRE_STATS_LOSS								, "Loss: ");
		add(WIRE_STATS_VOLTAGE							, "Voltage: ");
		add(WIRE_STATS_AMPERAGE							, "Amperage: ");
		add(PIPE_STATS_LOSS								, "Loss: ");
		add(PIPE_STATS_RANGE							, "Range: ");
		add(PIPE_STATS_STEPSIZE							, "Stepsize: ");
		add(PIPE_STATS_BANDWIDTH						, "Bandwidth: ");
		add(PIPE_STATS_CAPACITY							, "Capacity: ");
		add(HAZARD_FIRE									, "Can put Blocks around it on Fire!");
		add(HAZARD_EXPLOSION_STEAM						, "Explodes when Steam Pressure is too high!");
		add(HAZARD_MELTDOWN								, "Melts down when stored Heat is too much!");
		add(HAZARD_CONTACT								, "Causes Damage when touched while active!");
		add(HAZARD_LEAKING_GAS							, "Leaks when used with Gasses!");
		add(TOOLTIP_SPAWNPROOF							, "Mobs cannot Spawn on this Block");
		add(TOOLTIP_BLASTRESISTANCE						, "Blast Resistance: ");
		add(ADVCRAFTING_INSERT_BLUEPRINT				, "Insert a Blueprint here");
		add(ADVCRAFTING_PUT_TO_STORAGE					, "Move Crafting Grid content to Storage Slots");
		add(ADVCRAFTING_AUTOMATION_ACCESS				, "Allow Automation to extract from the Crafting Grid");
		add(ADVCRAFTING_NEUTRAL_SLOT					, "This Slot does ABSOLUTELY NOTHING to its content");
		add(ADVCRAFTING_DROP_SLOT						, "Automation can extract Items you drop into this Slot");
		add(TIME_TICK									, "Tick");
		add(TIME_SEC									, "Second");
		add(TIME_MIN									, "Minute");
		add(TIME_HOUR									, "Hour");
		add(TIME_DAY									, "Day");
		add(TIME_WEEK									, "Week");
		add(TIME_TICKS									, "Ticks");
		add(TIME_SECS									, "Seconds");
		add(TIME_MINS									, "Minutes");
		add(TIME_HOURS									, "Hours");
		add(TIME_DAYS									, "Days");
		add(TIME_WEEKS									, "Weeks");
		add(WIP											, Chat.RESET + Chat.WHITE + Chat.BOLD + "WIP" + Chat.RESET_TOOLTIP + ", This may not be as functional as you expect it to be!");
	}
	
	public static class Chat {
		public static final String
		  BLACK = EnumChatFormatting.BLACK.toString()
		, DBLUE = EnumChatFormatting.DARK_BLUE.toString()
		, DGREEN = EnumChatFormatting.DARK_GREEN.toString()
		, DCYAN = EnumChatFormatting.DARK_AQUA.toString()
		, DRED = EnumChatFormatting.DARK_RED.toString()
		, PURPLE = EnumChatFormatting.DARK_PURPLE.toString()
		, ORANGE = EnumChatFormatting.GOLD.toString()
		, GOLD = EnumChatFormatting.GOLD.toString()
		, GRAY = EnumChatFormatting.GRAY.toString()
		, DGRAY = EnumChatFormatting.DARK_GRAY.toString()
		, BLUE = EnumChatFormatting.BLUE.toString()
		, GREEN = EnumChatFormatting.GREEN.toString()
		, CYAN = EnumChatFormatting.AQUA.toString()
		, RED = EnumChatFormatting.RED.toString()
		, PINK = EnumChatFormatting.LIGHT_PURPLE.toString()
		, YELLOW = EnumChatFormatting.YELLOW.toString()
		, WHITE = EnumChatFormatting.WHITE.toString()
		, OBFUSCATED = EnumChatFormatting.OBFUSCATED.toString()
		, BOLD = EnumChatFormatting.BOLD.toString()
		, STRIKETHROUGH = EnumChatFormatting.STRIKETHROUGH.toString()
		, UNDERLINE = EnumChatFormatting.UNDERLINE.toString()
		, ITALIC = EnumChatFormatting.ITALIC.toString()
		, RESET = EnumChatFormatting.RESET.toString()
		, RESET_TOOLTIP = RESET + GRAY
		;
	}
}